#include <avr/io.h>
#include <util/delay.h>

//functie setare PORTD, PORTA, PORTC
void dac_func(int d, int a, int c){
	PORTD = d; 
	PORTA = a;
	PORTC = c;
}

//functie setare PORTA, PORTC
void ac_func(int a, int c){
	PORTA = a; 
	PORTC = c;
}



int main(){
	
	DDRD = 0xFF;
	DDRC = 0xFF;
	DDRA = 0xFF;
	
	int i;
	while (1) {
	
		//lumini care coboara
		i = 0;
		while (i < 2) {   
	        dac_func(0x80, 0xff, 0xff);
	        _delay_ms(3000);
	        dac_func(0x40, 0xff, 0xff);
	        _delay_ms(3000);
	        dac_func(0x20, 0xff, 0xff);
	        _delay_ms(3000);
	        dac_func(0x10, 0xff, 0xff);	
	        _delay_ms(3000);

        	i += 1;
        }
    

		//lumini care se plimba pe fiecare linie
        PORTD = 0x10;
        i = 0;
        while (i < 4) {

            int j = 0;

            ac_func(0x01, 0x00);
           

            j = 0;
            while (j < 16) {
                _delay_ms(800);
                PORTA = PORTA * 2;
                j += 1;
            }

            ac_func(0x00, 0x01);
          
           

            j = 0;
            while (j < 16) {
                _delay_ms(800);
                PORTC = PORTC * 2;
                j += 1;
            }

            PORTD = PORTD * 2;

            i += 1;
        }
    
    	//lumini care coboara
    	i = 0;
		while (i < 2) {
            dac_func(0x80, 0xff, 0xff);
            _delay_ms(3000);
            dac_func(0x40, 0xff, 0xff);
            _delay_ms(3000);
            dac_func(0x20, 0xff, 0xff);
            _delay_ms(3000);
            dac_func(0x10, 0xff, 0xff);	
            _delay_ms(3000);

            i += 1;
        }

		//lumini din stanga in dreapta 
		i = 0;
		while (i < 5) {
			dac_func(0xf0, 0x00, 0x3c);
			_delay_ms(2500);
			dac_func(0xf0, 0x00, 0xc3);
			_delay_ms(2500);
			dac_func(0xf0, 0xf0, 0x00);
			_delay_ms(2500);
			dac_func(0xf0, 0x0f, 0x00);
			_delay_ms(2500);
			dac_func(0xf0, 0xf0, 0x00);
			_delay_ms(2500);
			dac_func(0xf0, 0x00, 0xc3);
			_delay_ms(2500);

			i += 1;	
		}
		
		
		dac_func(0x30, 0x12, 0x00);
		_delay_ms(1000);
		dac_func(0xa0, 0x84, 0x00);
		_delay_ms(1000);
		dac_func(0xc0, 0x00, 0x48);
		_delay_ms(1000);
		dac_func(0xa0, 0x00, 0x12);
		_delay_ms(1000);
				
		
		//lumini care sunt in forma de cerc 
		while (i < 2) {
			dac_func(0x10, 0x01, 0x00);
			_delay_ms(200);
			dac_func(0x20, 0x20, 0x00);
			_delay_ms(200);
			dac_func(0x80, 0x00, 0x80);
			_delay_ms(200);
			dac_func(0x40, 0x00, 0x04);
			_delay_ms(200);
			dac_func(0x40, 0x00, 0x08);
			_delay_ms(200);
			dac_func(0x40, 0x00, 0x10);
			_delay_ms(200);
			dac_func(0x40, 0x00, 0x04);
			_delay_ms(200);
			dac_func(0x40, 0x00, 0x08);
			_delay_ms(200);
			dac_func(0x20, 0x40, 0x00);
			_delay_ms(200);
			dac_func(0x10, 0x08, 0x00);
			_delay_ms(200);
			dac_func(0x10, 0x04, 0x00);
			_delay_ms(200);
			dac_func(0x10, 0x02, 0x00);
			_delay_ms(200);

			i += 1;				
		}

		//lumini care coboara
		i = 0;
		while (i < 2) {
            dac_func(0x80, 0xff, 0xff);
            _delay_ms(3000);
            dac_func(0x40, 0xff, 0xff);
            _delay_ms(3000);
            dac_func(0x20, 0xff, 0xff);
            _delay_ms(3000);
            dac_func(0x10, 0xff, 0xff);	
            _delay_ms(3000);
            
            i += 1;
        }

       
		//se umple cubul stil labirint
		i = 0;
		while (i < 3) {
			dac_func(0xf0, 0x00, 0x20);
			_delay_ms(1200);		
			ac_func(0x00, 0x30);
			_delay_ms(1200);
			ac_func(0x00, 0x38);
			_delay_ms(1200);
			ac_func(0x00, 0x3c);
			_delay_ms(1200);
			ac_func(0x00, 0x7c);
			_delay_ms(1200);
			ac_func(0x00, 0xfc);
			_delay_ms(1200);
			ac_func(0x00, 0xfd);
			_delay_ms(1200);
			ac_func(0x00, 0xff);
			_delay_ms(1200);
			ac_func(0x10, 0xff);
			_delay_ms(1200);
			ac_func(0x30, 0xff);
			_delay_ms(1200);
			ac_func(0x70, 0xff);
			_delay_ms(1200);
			ac_func(0xf0, 0xff);
			_delay_ms(1200);
			ac_func(0xf8, 0xff);
			_delay_ms(1200);
			ac_func(0xfc, 0xff);
			_delay_ms(1200);
			ac_func(0xfe, 0xff);
			_delay_ms(1200);
			ac_func(0xff, 0xff);
			_delay_ms(1200);

			i += 1;
		}		
		
		//lumini care coboara
		i = 0;
		while (i < 2) {
	        dac_func(0x80, 0xff, 0xff);
	        _delay_ms(3000);
	        dac_func(0x40, 0xff, 0xff);
	        _delay_ms(3000);
	        dac_func(0x20, 0xff, 0xff);
	        _delay_ms(3000);
	        dac_func(0x10, 0xff, 0xff);	
	        _delay_ms(3000);

	        i += 1;
        }

        //de jos in sus pe cateva coloane
        i = 0;
		while (i < 5) {			
			dac_func(0x10, 0x00, 0x01);
            _delay_ms(2400);
            dac_func(0x20, 0x00, 0x01);
            _delay_ms(3000);
            dac_func(0x80, 0x00, 0x01);
            _delay_ms(3600);
            dac_func(0x40, 0x00, 0x01);
            _delay_ms(3600);
            dac_func(0x40, 0x50, 0x29);
            _delay_ms(3600);
            dac_func(0x80, 0x50, 0x28);
            _delay_ms(3000);
            dac_func(0x20, 0x50, 0x28);
            _delay_ms(2400);

			i += 1;
		}
		
		//lumini care coboara	
		i = 0;
		while (i < 2) {
			dac_func(0x80, 0xff, 0xff);
            _delay_ms(3000);
            dac_func(0x40, 0xff, 0xff);
            _delay_ms(3000);
            dac_func(0x20, 0xff, 0xff);
            _delay_ms(3000);
            dac_func(0x10, 0xff, 0xff);	
            _delay_ms(3000);
            
            i += 1;
        }

        //lumini care se plimba pe fiecare linie a fiecarui nivel
		i = 0;
		while (i < 9) {	
			int mod_patru = i % 4;
				
			if (mod_patru == 0) {
				PORTD=0x10;
			}

			if (mod_patru == 1) {
				PORTD=0x20;
			}

			if (mod_patru == 2) {
				PORTD=0x80;
			}

			if (mod_patru == 3) {
				PORTD=0x40;
			}

			ac_func(0x00, 0x20);
			_delay_ms(1200);
			ac_func(0x00, 0x10);
			_delay_ms(1200);
			ac_func(0x00, 0x08);
			_delay_ms(1200);
			ac_func(0x00, 0x04);
			_delay_ms(1200);
			ac_func(0x00, 0x40);
			_delay_ms(1200);
			ac_func(0x00, 0x80);
			_delay_ms(1200);
			ac_func(0x00, 0x01);
			_delay_ms(1200);
			ac_func(0x00, 0x02);
			_delay_ms(1200);
			ac_func(0x10, 0x00);
			_delay_ms(1200);
			ac_func(0x20, 0x00);
			_delay_ms(1200);
			ac_func(0x40, 0x00);
			_delay_ms(1200);
			ac_func(0x80, 0x00);
			_delay_ms(1200);
			ac_func(0x08, 0x00);
			_delay_ms(1200);
			ac_func(0x04, 0x00);
			_delay_ms(1200);
			ac_func(0x02, 0x00);
			_delay_ms(1200);
			ac_func(0x01, 0x00);
			_delay_ms(1200);
		
			i += 1;
		}		

	   	//lumini care coboara
		i = 0;
		while (i < 2) {
            dac_func(0x80, 0xff, 0xff);
            _delay_ms(3000);
            dac_func(0x40, 0xff, 0xff);
            _delay_ms(3000);
            dac_func(0x20, 0xff, 0xff);
            _delay_ms(3000);
            dac_func(0x10, 0xff, 0xff);	
            _delay_ms(3000);

            i += 1;
        }
		
	    //rotire lumini
		i = 0;
		while (i < 15) {	
			dac_func(0xf0, 0x48, 0x21);
	        _delay_ms(1000);
	        dac_func(0xf0, 0xc0, 0x03);
	        _delay_ms(1000);
	        dac_func(0xf0, 0x30, 0xc0);
	        _delay_ms(1000);
	        dac_func(0xf0, 0x21, 0x84);
	        _delay_ms(1000);
	        dac_func(0xf0, 0x22, 0x88);
	        _delay_ms(1000);
	        dac_func(0xf0, 0x44, 0x11);
	        _delay_ms(1000);

			i += 1;
		}

	}
	
	return 0;
}